<template>
  <div>
    <h2 class="is-size-4">
      <feather color="primary" />
      {{ $t('feathersRanking.label') }}
    </h2>

    <b-table
      :data="users"
      :striped="true"
      :loading="loading"
      :hoverable="true">
      <b-table-column field="rank"
                      centered
                      label="#"
                      v-slot="props">
        {{ props.index + 1 }}
      </b-table-column>

      <b-table-column field="player"
                      :label="$t('ranking.player')"
                      centered
                      v-slot="props">
        <router-link :to="{ name: 'User',
                            params: { id: props.row.id } }"
                      class="has-text-weight-bold has-text-green">
          {{ props.row.email }}
        </router-link>
      </b-table-column>

      <b-table-column field="feathers_count"
                      :label="$t('ranking.feathers')"
                      centered
                      v-slot="props">
        <feather v-for="i in props.row.feathers_count"
                 :key="i" />
      </b-table-column>
    </b-table>
  </div>
</template>

<script lang="ts">
import { Component } from 'vue-property-decorator';
import LoadingMixin from '../../mixins/loading.vue';
import { User } from './UserIndex.vue';
import Feather from '@/components/Feather.vue';

@Component({
  components: { Feather }
})
export default class FeathersRanking extends LoadingMixin {
  users: User[] = [];

  async mounted() {
    const { data } = await this.$http.get('scores/feathers_ranking');

    this.users = data;
    this.stopLoading();
  }
}
</script>
